
function initSortOrder()
{
    if(typeof(workflow) == 'undefined')
       workflow = "none";
    
	if(!isDefined(parent._rulesSortOrder)) 
      parent._rulesSortOrder = new Array();
   if(!isDefined(parent._rulesSortOrder[workflow]))   
      setSortOrder("0", "desc"); // default
}

function setSortOrder(colId, order)
{
   if(typeof(workflow) == 'undefined')
      workflow = "none";

   sortCol = new Object();
   sortCol.colId = colId;
   sortCol.order = order;
   if(!isDefined(parent._rulesSortOrder))
      parent._rulesSortOrder = new Array();
   parent._rulesSortOrder[workflow] = sortCol;
   
   // alert("sort col " + colId + ", " + order);

}

function getSortOrder()
{
	if(typeof(workflow) == 'undefined')
       workflow = "none";

	if (isDefined(parent._rulesSortOrder) && isDefined(parent._rulesSortOrder[workflow]))
      return parent._rulesSortOrder[workflow].colId + " " + parent._rulesSortOrder[workflow].order;
    else
      return "";
}


function getSortCol()
{
	   if(typeof(workflow) == 'undefined')
		      workflow = "none";

	return parent._rulesSortOrder[workflow];
}

function sortRules(tableId)
{
   if(typeof(workflow) == 'undefined')
      workflow = "none";
	
   // alert(workflow);
   initSortOrder();
   
   colId = parent._rulesSortOrder[workflow].colId;
   order = parent._rulesSortOrder[workflow].order;
   // alert("Sorting by " + colId + ", " + order);
   
   var table = getElement(tableId);
   if (!table)
       return; // handle zero rules condition
   var headerRow = table.tHead.rows[0];   
   var cellCount = headerRow.cells.length;      
   var headerCell = headerRow.cells[colId];        
   var dataType = headerCell.getAttribute("famSortType");                 
   
   sortTable(tableId, headerCell.cellIndex, dataType);
   
   if(order == "desc") // need to find a better way to do desc sorting
      sortTable(tableId, headerCell.cellIndex, dataType);               
        
}


/*
* tables - an array of table ids
*/
function attachEventHandlerToTableCells(tables)
{
   for(var t in tables)
   {
      enableSortableColumns(tables[t]);
      // enablePopups(tables[t]);
   }
}

// Parameters:
//    tableId:  tableId
//    col:      0-based column number in table
//    dataType: 'int', 'float', 'date';  not required, if empty will default to text
function sortTable(tableId, col, dataType)
{
   // alert(col);
   var table = document.getElementById(tableId);
   var tBody = table.tBodies[0];
   var newTRs = new Array;

   for (var i=0; i < tBody.rows.length; i++)
   {
      newTRs[i] = tBody.rows[i];
   }
   
   _order = "asc";   
   if (table.sortCol == col)
   {
      newTRs.reverse();      
      
      // special case to handle already selected column in workflow
      workflowSortCol = getSortCol();
      if(isDefined(workflowSortCol) && workflowSortCol.colId == col)
      {   
         if(workflowSortCol.order == "desc")
            _order = "asc";
         else
            _order = "desc";         
      }
      else
         _order = "desc";
   }
   else
   {
      newTRs.sort(getComparator(col, dataType));
   }
   
   // alert(_order);

   var fragment = document.createDocumentFragment();
   for (var i=0; i < newTRs.length; i++)
   {
      fragment.appendChild(newTRs[i]);
   }

   tBody.appendChild(fragment);
   table.sortCol = col;  
   
   // alert(_order);
   setSortOrder(col, _order);

   alternateRowClassNames(tableId, 'dataRow1_tableRow', 'dataRow2_tableRow')
}

function getComparator(col, dataType)
{
   return function comparator(tr1, tr2)
         {
            var value1, value2;
            if (dataType && dataType=='localDate') {
              value1 = (tr1.cells[col]) ? convert(tr1.cells[col], dataType) : '';
              value2 = (tr2.cells[col]) ? convert(tr2.cells[col], dataType) : '';
            }
            else {
              value1 = (tr1.cells[col].firstChild != null) ? convert(tr1.cells[col].firstChild.nodeValue, dataType) : '';
              value2 = (tr2.cells[col].firstChild != null) ? convert(tr2.cells[col].firstChild.nodeValue, dataType) : '';
            }
            
            if (value1 < value2)
            {
               return -1;
            }
            else if (value1 > value2)
            {
               return 1;
            }
            else
            {
               return 0;
            }
         };
}

// expects date and time in the format mm/dd/yyyy hh:mm:ss a
// 10/12/2006 12:05:23 PM 

// cache date times for efficiency
 var dateTimeMap = new Array(); 

function convert(value, dataType)
{
   switch(dataType)
   {
      case "num":
         return  parseFloat(value.replace(',',''));
      case "date":
         return new Date(2000+parseInt(value.substr(value.lastIndexOf('/')+1)), value.substring(0,value.indexOf('/'))-1, value.substring(value.indexOf('/')+1,value.lastIndexOf('/')));
      case "time":
         return new Date(2000,1,1,parseFloat(value.substring(0,value.indexOf(':'))),parseFloat(value.substring(value.indexOf(':')+1,value.lastIndexOf(':'))),parseFloat(value.substr(value.lastIndexOf(':')+1)));
      case "dateTime":
         var dateTime = dateTimeMap[value];
         if(dateTime == null || dateTime == undefined)
         {         
            var dateTime = new Date(2000+parseInt(value.substr(value.lastIndexOf('/')+1)), 
                                 value.substring(0,value.indexOf('/'))-1, 
                                 value.substring(value.indexOf('/')+1,value.lastIndexOf('/')),
                                 parseFloat(value.substring( value.indexOf(' '),value.indexOf(':'))),
                                 parseFloat(value.substring(value.indexOf(':')+1,value.lastIndexOf(':'))),
                                 parseFloat(value.substr(value.lastIndexOf(':') +1, value.lastIndexOf(':') + 3 )) );
          
            if(value.indexOf("PM") != -1 || value.indexOf("pm") != -1)
            {            
               dateTime.setHours(dateTime.getHours()%12 + 12);         
            }
            if(isNaN(dateTime)) // handle null values
               dateTime = "";  
            dateTimeMap[value] = dateTime;
         }
         return dateTime;
      case "localDate":
         var sts = value.getElementsByTagName("SPAN");
         if (sts && sts.length > 0) 
         {
        	 var element = sts[0];
        	 var valueStr = element.getAttribute("sortvalue");
        	 value = parseInt(valueStr);
        	 return value;
         }
         return 0;
      default:
         return (!value) ? "" : value.toString().toUpperCase();
   }
}

function alternateRowClassNames(tableId, oddClass, evenClass)
{
   var table = document.getElementById(tableId);
   var rows = table.tBodies[0].rows;
   for (var i=0; i<rows.length; i++)
   {
      rows[i].className = (i % 2) ? evenClass : oddClass;
   }
}



function enableSortableColumns(tableId)
{
   if(!getElement(tableId) || !getElement(tableId).tHead ) return;

   // Event handler
   var clickAction = function() {
                        var dataType = this.parentNode.getAttribute("famSortType");
                        sortTable(tableId,
                                    this.parentNode.cellIndex,
                                       dataType);
                        return false;
                     };

   var headerRow = getElement(tableId).tHead.rows[0];
   var cellCount = headerRow.cells.length;
   var sortAnchor = document.createElement("A");
   sortAnchor.className="sort";
   sortAnchor.href = "#";

   for(var j = 0; j < cellCount; j++)
   {
      var headerCell = headerRow.cells[j];
      var isSortableOn = (headerCell.getAttribute("rules:sortAsText") != null ? "text" : null ||
                           headerCell.getAttribute("rules:sortAsNum") != null ? "num" : null ||
                            headerCell.getAttribute("rules:sortAsDate") != null ? "date" : null ||
                             headerCell.getAttribute("rules:sortAsTime") != null ? "time" : null ||
                              headerCell.getAttribute("rules:sortAsLocalDate") != null ? "localDate" : null ||
                               headerCell.getAttribute("rules:sortAsDateTime") != null ? "dateTime" : null );
      if(isSortableOn && headerCell.hasChildNodes())
      {
    	 headerCell.setAttribute("famSortType", isSortableOn);
         var oldNode = headerCell.firstChild;
         var newNode = sortAnchor.cloneNode(true);
         newNode.appendChild(oldNode.cloneNode(false));
         newNode.onclick = clickAction;
         headerCell.replaceChild(newNode,oldNode);
      }
   }
}

function appendClassName(origClassName,newClassName)
{
   return function(){this.className=origClassName+" "+ newClassName;};
}

function fireOnMouseUp(evt)
{
   // IE doesn't consider this a mouseup when clicking on a scrollable grid
   // force a mouse up event
   if(window.event)
   {
      document.onmouseup(window.event);
   }

}
