/*
 * Subsetting dataset based on on where condition
 * 
 * Author: Song, Qiang <qiang.song@sas.com> 2015
 * 
 */

%macro apply_dataset_filter(
    in =,          
    out =,         
    filter_file = 
    );

    data &out;
        set &in;
        %filter_mac;        
    run;    

    %local skipThisTran_exist;
    data _null_;
        dsid = open("&out");

        f = ifc(varnum(dsid, "skipThisTran"),"Y", "N");
        call symputx('skipThisTran_exist', f);
    run;
    
    %if &skipThisTran_exist eq Y %then %do;
        data &out;
            set &out;
            where not skipThisTran;
        run;
    %end;    

%mend apply_dataset_filter;

     
