%macro create_augmented(in =, out =);
  %let _i=1; %let numds=0;
  %do %until(%scan(&IN.,&_i,%str( ))=%str());
    %let numds=&_i;
    %let _i=%eval(&_i + 1);
  %end;
  %let _i=1;
  data &out;
    %if &numds=1 %then %do;
      set &in.(obs=max);
    %end;
    %else %do;
      merge 
        %do %until(%scan(&IN.,&_i,%str( ))=%str());
          %let thisds=%scan(&IN.,&_i,%str( ));
          &thisds.(obs=max)
          %let _i=%eval(&_i + 1);
        %end;
        ;
      by &CARDNUMBER;
    %end;

    %if &USE_AFD=1 %then %do;
      FRD_FIRST_DATE_RES=AFD_DOFF;
      FRD_FIRST_TIME_RES=AFD_DOFF_TIME;
      FRD_BLOCK_DATE_PROXY=AFD_BLOCK_DATE;
      FRD_BLOCK_TIME_PROXY=AFD_BLOCK_TIME;
      FRD_FRAUD_TYPE_RES=AFD_FRD_TYPE;
    %end;
    %else %do;
      /* Set up and use HASH for frauds */
      length FRD_FIRST_DATE_RES FRD_FIRST_TIME_RES FRD_BLOCK_DATE_PROXY FRD_BLOCK_TIME_PROXY 8;
      length FRD_FRAUD_TYPE_RES $2;
      if _n_=1 then do; 
        declare hash ho(dataset: "frdlib.&FRDSET.", hashexp: 16);
        ho.defineKey("&CARDNUMBER");
        ho.defineData('FRD_FIRST_DATE_RES','FRD_FIRST_TIME_RES',
          'FRD_BLOCK_DATE_PROXY','FRD_BLOCK_TIME_PROXY','FRD_FRAUD_TYPE_RES');
        ho.defineDone();
        call missing(FRD_FRAUD_TYPE_RES,FRD_FIRST_DATE_RES,FRD_FIRST_TIME_RES,
          FRD_BLOCK_DATE_PROXY,FRD_BLOCK_TIME_PROXY);
      end;

      rc=ho.find();
      if (rc^=0) then call missing(FRD_FRAUD_TYPE_RES,FRD_FIRST_DATE_RES,FRD_FIRST_TIME_RES,
          FRD_BLOCK_DATE_PROXY,FRD_BLOCK_TIME_PROXY);
    %end;

    %if "&KEEPLIST." ne "/dev/null" %then %do;
      keep
        &KEEPLIST.;
      ;
    %end;
    keep &TRAN_ID.
         &CARDNUMBER
         RQO_PROC_UTC_DATETIME
         RRR_SCORE_1
         &TAG
         &AUTH_AMT
         &AUTH_DEC
      FRD_FRAUD_TYPE_RES
      FRD_FIRST_DATE_RES
      FRD_FIRST_TIME_RES
      FRD_BLOCK_DATE_PROXY
      FRD_BLOCK_TIME_PROXY
    ;
    %if &INCLUDE_POSTINGS=1 %then %do;
      keep &POST_AMT &POST_PURCH_DATE;
    %end;
    output;
  run;
%mend create_augmented;
