%macro gain_table_onepage(inds= ,cwidth=0.20in,blankwidth=0.60in,title=Gains Table with Key Metrics);

data check;
 set &inds(keep=cdr vdr cutoff cfpr outsort) end=last;
   where cutoff >= 600 or mod(cutoff, 10) = 0;

if _n_=1 then group=1;
counter+1;
if mod(counter,40)=0 then do; group+1; counter=1; end; blank=" ";
if last then call symputx('lastgroup',group);
run;

 
data %do j=1 %to &lastgroup; temp_qqq_&j %end;;
 set check;

 %do j=1 %to &lastgroup;
 %if &j=1 %then %str(if group=&j then output temp_qqq_&j;);
 	      %else %str(else if group=&j then output temp_qqq_&j;);
 %end;
 run;

data all;
length counter 8;
merge %do j=1 %to &lastgroup; 
         temp_qqq_&j(keep=counter cutoff cdr vdr cfpr outsort blank rename=(cutoff=cutoff_&j cdr=cdr_&j vdr=vdr_&j cfpr=cfpr_&j outsort=outsort_&j blank=blank_&j)) 
      %end;;
by counter;
holder=1;
run;

ods proclabel "Gains Table";

options missing=' ';
proc report data=all contents="";
title "&title";
columns %do j=1 %to &lastgroup;
        cutoff_&j cdr_&j vdr_&j cfpr_&j outsort_&j blank_&j
		%end;holder;
%do j=1 %to &lastgroup;
	define cutoff_&j./display "Cutoff" format=4.0 style(column)=[cellwidth=&cwidth];
	define cdr_&j./display "CDR" format=5.2 style(column)=[cellwidth=&cwidth];
	define vdr_&j./display "VDR" format=5.2 style(column)=[cellwidth=&cwidth];
	define cfpr_&j./display "CFPR" format=5.2 style(column)=[cellwidth=&cwidth];
	define outsort_&j./display "Outsort" format=percent10.2 style(column)=[cellwidth=&cwidth];
	define blank_&j./display " "  style(column)=[cellwidth=&blankwidth];
	define holder/order noprint;
	break before holder/page contents='';
%end;
run;
options missing='.';

%do j=1 %to &lastgroup;
 %delit(ds=temp_qqq_&j);
%end;
%delit(ds=check);
%delit(ds=all);

%mend gain_table_onepage;
