/*
 * estimate first day of fraud and block date from fraud tagging
 * 
 * Author: Song, Qiang <qiang.song@sas.com> 2015
 * 
 */

%macro get_frd_window_dtm(in = , out =);
    %let randnum = %sysfunc(ranuni(0));
    %let randnum = %sysevalf(&randnum * 1234567890, ceil);

    %let tmpdst = _tmp_&randnum;
    
    proc sort equals nodupkey
        data = &in
        out = &tmpdst;
        by &entity  RQO_TRAN_DATE RQO_TRAN_TIME;
    run;
    
    
    data &out(keep = &entity dtm_ff dtm_blk);
        set &tmpdst;
        by &entity;

        rqo_tran_datetime = sum(rqo_tran_date * 86400, rqo_tran_time);
        
        retain dtm_last_2 dtm_first_1 dtm_last_1 dtm_first_3;
    
        if first.&entity then do;
            call missing(dtm_last_2, dtm_first_1, dtm_last_1, dtm_first_3);
        end;
    
        if afd_frd_tag = "2" and (missing(dtm_last_2) or rqo_tran_datetime > dtm_last_2) then
            dtm_last_2 = rqo_tran_datetime;

        if afd_frd_tag = "1" and missing(dtm_first_1)  then
            dtm_first_1 = rqo_tran_datetime;
    
        if afd_frd_tag = "1" and (missing(dtm_last_1) or rqo_tran_datetime > dtm_last_1) then
            dtm_last_1 = rqo_tran_datetime;

        if afd_frd_tag = "3" and missing(dtm_first_3)  then
            dtm_first_3 = rqo_tran_datetime;
        
        if last.&entity then do;
            call missing(dtm_ff, dtm_blk);
            format dtm_ff datetime. dtm_blk datetime.;
    
            if not missing(dtm_first_1) then
                dtm_ff = dtm_first_1 - 0.01;
    
            if not missing(dtm_first_3) then
                dtm_blk = dtm_first_3 - 0.01;
    
            if missing(dtm_ff) and not missing(dtm_last_2) then
                dtm_ff = dtm_last_2 + 0.01;

            if missing(dtm_ff) and not missing(dtm_first_3) then
                dtm_ff = dtm_first_3 - 0.02;
    
            if missing(dtm_blk) and not missing(dtm_last_1) then
                dtm_blk = dtm_last_1 + 0.01;
    
            output;
        end;
    run;

    %delete_dataset(&tmpdst);

%mend get_frd_window_dtm;
