%macro plot_quarterly(ds=,xaxis=,yaxis=,xaxis_options=, yaxis_options=, title=,where_statement=%str(1=1));

options orientation=landscape;
ods graphics/height=7.5in width=10in antialiasmax=4100;

ods proclabel "&title";
    
proc sgplot data=&ds description="Performance Curve";
series x=&xaxis y=&yaxis/group=label lineattrs=(thickness=2) markers;
keylegend/title="Time Period";
where &where_statement;
%if %bquote(&xaxis_options) ne %str( ) %then xaxis &xaxis_options;;
%if %bquote(&yaxis_options) ne %str( ) %then yaxis &yaxis_options;;
title "&yaxis vs. &xaxis";
run; 

%mend plot_quarterly;
